Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 4226)
+++ /palm/trunk/SOURCE/parin.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4146 2019-08-07 07:47:36Z gronemeier
 ! added rotation_angle to initialization_parameters
 ! 
@@ -94,7 +97,4 @@
     USE cpulog,                                                                &
         ONLY:  cpu_log_barrierwait
-
-    USE date_and_time_mod,                                                     &
-        ONLY:  date_init, day_of_year_init, time_utc_init
 
     USE grid_variables,                                                        &
@@ -164,6 +164,5 @@
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
-             date_init,                                                        &
-             day_of_year_init,                                                 &
+             origin_date_time,                                                 &
              dissipation_1d,                                                   &
              dp_external, dp_level_b, dp_smooth, dpdxy,    &
@@ -203,5 +202,5 @@
              surface_scalarflux, surface_waterflux,                            &
              s_surface, s_surface_initial_change, s_vertical_gradient,         &
-             s_vertical_gradient_level, time_utc_init, timestep_scheme,        &
+             s_vertical_gradient_level, timestep_scheme,                       &
              topography, topography_grid_convention, top_heatflux,             &
              top_momentumflux_u, top_momentumflux_v,                           &
@@ -238,6 +237,5 @@
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
-             date_init,                                                        &
-             day_of_year_init,                                                 &
+             origin_date_time,                                                 &
              dissipation_1d,                                                   &
              dp_external, dp_level_b, dp_smooth, dpdxy,                        &
@@ -276,5 +274,5 @@
              surface_scalarflux, surface_waterflux,                            &
              s_surface, s_surface_initial_change, s_vertical_gradient,         &
-             s_vertical_gradient_level, time_utc_init, timestep_scheme,        &
+             s_vertical_gradient_level, timestep_scheme,                       &
              topography, topography_grid_convention, top_heatflux,             &
              top_momentumflux_u, top_momentumflux_v,                           &
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4227)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4226 2019-09-10 17:03:24Z suehring
 ! - Netcdf input routine for dimension length renamed
 ! - Define time variable for external radiation input relative to time_utc_init 
@@ -232,9 +235,4 @@
          ONLY:  ddx, ddy, dx, dy 
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  calc_date_and_time, d_hours_day, d_seconds_hour, d_seconds_year,&
-               day_of_year, d_seconds_year, day_of_month, day_of_year_init,    &
-               init_date_and_time, month_of_year, time_utc_init, time_utc
-
     USE indices,                                                               &
         ONLY:  nnx, nny, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,   &
@@ -275,4 +273,8 @@
                real_1d_3d,                                                     &
                vars_pids
+
+    USE palm_date_time_mod,                                                    &
+        ONLY:  date_time_str_len, get_date_time,                               &
+               hours_per_day, seconds_per_hour
 
     USE plant_canopy_model_mod,                                                &
@@ -387,6 +389,10 @@
                 time_radiation = 0.0_wp            !< time since last call of radiation code
 
+    INTEGER(iwp) ::  day_of_year   !< day of the current year
 
     REAL(wp) ::  cos_zenith        !< cosine of solar zenith angle, also z-coordinate of solar unit vector
+    REAL(wp) ::  d_hours_day       !< 1 / hours-per-day
+    REAL(wp) ::  d_seconds_hour    !< 1 / seconds-per-hour
+    REAL(wp) ::  second_of_day     !< second of the current day
     REAL(wp) ::  sun_dir_lat       !< y-coordinate of solar unit vector
     REAL(wp) ::  sun_dir_lon       !< x-coordinate of solar unit vector
@@ -1520,4 +1526,9 @@
           CALL message( 'init_3d_model', 'PA0348', 0, 1, 0, 6, 0 )
        ENDIF
+!
+!--    Precalculate some time constants
+       d_hours_day    = 1.0_wp / REAL( hours_per_day, KIND = wp )
+       d_seconds_hour = 1.0_wp / seconds_per_hour
+
 !
 !--    If required, initialize radiation interactions between surfaces 
@@ -2280,8 +2291,8 @@
 !--       Calculate initial values of current (cosine of) the zenith angle and 
 !--       whether the sun is up
-          CALL calc_zenith
-!
-!--       readjust date and time to its initial value
-          CALL init_date_and_time
+          CALL get_date_time( time_since_reference_point, &
+                              day_of_year=day_of_year,    &
+                              second_of_day=second_of_day )
+          CALL calc_zenith( day_of_year, second_of_day )
 !
 !--       Calculate initial surface albedo for different surfaces
@@ -2640,12 +2651,14 @@
           ENDIF
           
-          IF ( time_rad_f%var1d(0) /= time_utc_init )  THEN
+          CALL get_date_time( 0.0_wp, second_of_day=second_of_day )
+
+          IF ( time_rad_f%var1d(0) /= second_of_day )  THEN
              message_string = 'External radiation forcing: first point in ' // &
-                              'time is /= time_utc_init.'
+                              'time is /= origin_date_time.'
              CALL message( 'radiation_init', 'PA0313', 1, 2, 0, 6, 0 )
           ENDIF
           
           IF ( end_time - spinup_time > time_rad_f%var1d(ntime-1)              &
-                                      - time_utc_init )  THEN
+                                      - second_of_day )  THEN
              message_string = 'External radiation forcing does not cover ' //  &
                               'the entire simulation time.'
@@ -2765,7 +2778,4 @@
 
        END SELECT
-!
-!--    Readjust date and time to its initial value
-       CALL init_date_and_time
 
 !
@@ -2821,5 +2831,6 @@
        LOGICAL      ::  horizontal !< flag indicating treatment of horinzontal surfaces
        
-       REAL(wp) ::  fac_dt     !< interpolation factor  
+       REAL(wp) ::  fac_dt               !< interpolation factor  
+       REAL(wp) ::  second_of_day_init   !< second of the day at model start
 
        TYPE(surf_type), POINTER ::  surf !< pointer on respective surface type, used to generalize routine   
@@ -2827,5 +2838,8 @@
 !
 !--    Calculate current zenith angle
-       CALL calc_zenith
+       CALL get_date_time( time_since_reference_point, &
+                           day_of_year=day_of_year,    &
+                           second_of_day=second_of_day )
+       CALL calc_zenith( day_of_year, second_of_day )
 !
 !--    Interpolate external radiation on current timestep 
@@ -2835,7 +2849,8 @@
           fac_dt = 0
        ELSE
+          CALL get_date_time( 0.0_wp, second_of_day=second_of_day_init )
           t = 0
           DO WHILE ( time_rad_f%var1d(t) <=                                    &
-                     time_since_reference_point + time_utc_init )
+                     time_since_reference_point + second_of_day_init )
              t = t + 1
           ENDDO
@@ -2843,5 +2858,5 @@
           tm = MAX( t-1, 0 )
           
-          fac_dt = ( time_since_reference_point + time_utc_init                &
+          fac_dt = ( time_since_reference_point + second_of_day_init           &
                    - time_rad_f%var1d(tm) + dt_3d )                            &
                  / ( time_rad_f%var1d(t)  - time_rad_f%var1d(tm) )
@@ -3067,11 +3082,10 @@
     SUBROUTINE radiation_clearsky
 
-
        IMPLICIT NONE
 
        INTEGER(iwp) ::  l         !< running index for surface orientation
-       
+
        LOGICAL      ::  horizontal !< flag indicating treatment of horinzontal surfaces
-       
+
        REAL(wp)     ::  pt1       !< potential temperature at first grid level or mean value at urban layer top 
        REAL(wp)     ::  pt1_l     !< potential temperature at first grid level or mean value at urban layer top at local subdomain 
@@ -3083,5 +3097,8 @@
 !
 !--    Calculate current zenith angle
-       CALL calc_zenith
+       CALL get_date_time( time_since_reference_point, &
+                           day_of_year=day_of_year,    &
+                           second_of_day=second_of_day )
+       CALL calc_zenith( day_of_year, second_of_day )
 
 !
@@ -3632,4 +3649,7 @@
            ONLY:  nbgp
 
+       USE palm_date_time_mod,                                                 &
+           ONLY:  hours_per_day
+
        USE particle_attributes,                                                &
            ONLY:  grid_particles, number_of_particles, particles, prt_count
@@ -3642,4 +3662,5 @@
        INTEGER(iwp) ::  k_topo     !< topography top index
 
+       REAL(wp)     ::  d_hours_day  !< 1 / hours-per-day
        REAL(wp)     ::  nc_rad, &    !< number concentration of cloud droplets
                         s_r2,   &    !< weighted sum over all droplets with r^2
@@ -3662,6 +3683,13 @@
 
 !
+!--    Pre-calculate parameters
+       d_hours_day = 1.0_wp / REAL( hours_per_day, KIND=wp )
+
+!
 !--    Calculate current (cosine of) zenith angle and whether the sun is up
-       CALL calc_zenith     
+       CALL get_date_time( time_since_reference_point, &
+                           day_of_year=day_of_year,    &
+                           second_of_day=second_of_day )
+       CALL calc_zenith( day_of_year, second_of_day )
        zenith(0) = cos_zenith
 !
@@ -4548,19 +4576,21 @@
 !> Calculate the cosine of the zenith angle (variable is called zenith)
 !------------------------------------------------------------------------------!
-    SUBROUTINE calc_zenith
+    SUBROUTINE calc_zenith( day_of_year, second_of_day ) 
+
+       USE palm_date_time_mod,                                                 &
+           ONLY:  seconds_per_day
 
        IMPLICIT NONE
 
-       REAL(wp) ::  declination,  & !< solar declination angle
-                    hour_angle      !< solar hour angle
-!
-!--    Calculate current day and time based on the initial values and simulation
-!--    time
-       CALL calc_date_and_time
-
-!
-!--    Calculate solar declination and hour angle   
+       INTEGER(iwp), INTENT(IN) ::  day_of_year    !< day of the year
+
+       REAL(wp)                 ::  declination    !< solar declination angle
+       REAL(wp)                 ::  hour_angle     !< solar hour angle
+       REAL(wp),     INTENT(IN) ::  second_of_day  !< current time of the day in UTC
+
+!
+!--    Calculate solar declination and hour angle
        declination = ASIN( decl_1 * SIN(decl_2 * REAL(day_of_year, KIND=wp) - decl_3) )
-       hour_angle  = 2.0_wp * pi * (time_utc / 86400.0_wp) + lon - pi
+       hour_angle  = 2.0_wp * pi * ( second_of_day / seconds_per_day ) + lon - pi
 
 !
@@ -5417,6 +5447,10 @@
 
      sun_direction = .TRUE.
-     CALL calc_zenith  !< required also for diffusion radiation
-
+     CALL get_date_time( time_since_reference_point, &
+                         day_of_year=day_of_year,    &
+                         second_of_day=second_of_day )
+     CALL calc_zenith( day_of_year, second_of_day ) !< required also for diffusion radiation
+
+!
 !--     prepare rotated normal vectors and irradiance factor
      vnorm(1,:) = kdir(:)
@@ -6240,22 +6274,29 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE calc_diffusion_radiation 
-    
-        INTEGER(iwp)         ::  i                       !< grid index x-direction
-        INTEGER(iwp)         ::  j                       !< grid index y-direction
-        
-        REAL(wp)             ::  year_angle              !< angle
-        REAL(wp)             ::  etr                     !< extraterestrial radiation
-        REAL(wp)             ::  corrected_solarUp       !< corrected solar up radiation
-        REAL(wp)             ::  horizontalETR           !< horizontal extraterestrial radiation
-        REAL(wp)             ::  clearnessIndex          !< clearness index
-        REAL(wp)             ::  diff_frac               !< diffusion fraction of the radiation
-        
-        REAL(wp), PARAMETER  ::  lowest_solarUp = 0.1_wp  !< limit the sun elevation to protect stability of the calculation
-!  
+
+       USE palm_date_time_mod,                                                 &
+           ONLY:  seconds_per_day
+
+       INTEGER(iwp)        ::  i                        !< grid index x-direction
+       INTEGER(iwp)        ::  j                        !< grid index y-direction
+       INTEGER(iwp)        ::  days_per_year            !< days in the current year
+
+       REAL(wp)            ::  clearnessIndex           !< clearness index
+       REAL(wp)            ::  corrected_solarUp        !< corrected solar up radiation
+       REAL(wp)            ::  diff_frac                !< diffusion fraction of the radiation
+       REAL(wp)            ::  etr                      !< extraterestrial radiation
+       REAL(wp)            ::  horizontalETR            !< horizontal extraterestrial radiation
+       REAL(wp), PARAMETER ::  lowest_solarUp = 0.1_wp  !< limit the sun elevation to protect stability of the calculation
+       REAL(wp)            ::  second_of_year           !< current second of the year
+       REAL(wp)            ::  year_angle               !< angle
+
+!
 !--     Calculate current day and time based on the initial values and simulation time
-        year_angle = ( (day_of_year_init * 86400) + time_utc_init              &
-                        + time_since_reference_point )  * d_seconds_year       &
-                        * 2.0_wp * pi
-        
+        CALL get_date_time( time_since_reference_point,      &
+                            second_of_year = second_of_year, &
+                            days_per_year = days_per_year    )
+        year_angle = second_of_year / ( REAL( days_per_year, KIND=wp ) * seconds_per_day ) &
+                   * 2.0_wp * pi
+
         etr = solar_constant * (1.00011_wp +                                   &
                           0.034221_wp * cos(year_angle) +                      &
@@ -6263,5 +6304,5 @@
                           0.000719_wp * cos(2.0_wp * year_angle) +             &
                           0.000077_wp * sin(2.0_wp * year_angle))
-!       
+        
 !--    
 !--     Under a very low angle, we keep extraterestrial radiation at
@@ -8564,10 +8605,8 @@
       IMPLICIT NONE
 
-      INTEGER(iwp)                              ::  it, i, j
-      INTEGER(iwp)                              ::  day_of_month_prev,month_of_year_prev
-      REAL(wp)                                  ::  tsrp_prev
-      REAL(wp)                                  ::  simulated_time_prev
-      REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  dsidir_tmp       !< dsidir_tmp[:,i] = unit vector of i-th
-                                                                     !< appreant solar direction
+      INTEGER(iwp) ::  it, i, j                           !< loop indices
+
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: dsidir_tmp !< dsidir_tmp[:,i] = unit vector of i-th
+                                                          !< appreant solar direction
 
       ALLOCATE ( dsidir_rev(0:raytrace_discrete_elevs/2-1,                 &
@@ -8577,24 +8616,11 @@
                      raytrace_discrete_elevs/2*raytrace_discrete_azims) )
       ndsidir = 0
-
-!
-!--   We will artificialy update time_since_reference_point and return to
-!--   true value later
-      tsrp_prev = time_since_reference_point
-      simulated_time_prev = simulated_time
-      day_of_month_prev = day_of_month
-      month_of_year_prev = month_of_year
       sun_direction = .TRUE.
-
-!
-!--   initialize the simulated_time
-      simulated_time = 0._wp
+      
 !
 !--   Process spinup time if configured
       IF ( spinup_time > 0._wp )  THEN
          DO  it = 0, CEILING(spinup_time / dt_spinup)
-            time_since_reference_point = -spinup_time + REAL(it, wp) * dt_spinup
-            simulated_time = simulated_time + dt_spinup
-            CALL simulate_pos
+            CALL simulate_pos( it * dt_spinup - spinup_time )
          ENDDO
       ENDIF
@@ -8602,16 +8628,7 @@
 !--   Process simulation time
       DO  it = 0, CEILING(( end_time - spinup_time ) / dt_radiation)
-         time_since_reference_point = REAL(it, wp) * dt_radiation
-         simulated_time = simulated_time + dt_radiation
-         CALL simulate_pos
+         CALL simulate_pos( it * dt_radiation )
       ENDDO
 !
-!--   Return date and time to its original values
-      time_since_reference_point = tsrp_prev
-      simulated_time = simulated_time_prev
-      day_of_month = day_of_month_prev
-      month_of_year = month_of_year_prev
-      CALL init_date_and_time
-
 !--   Allocate global vars which depend on ndsidir
       ALLOCATE ( dsidir ( 3, ndsidir ) )
@@ -8634,9 +8651,13 @@
       !> Simuates a single position
       !------------------------------------------------------------------------!
-      SUBROUTINE simulate_pos
-         IMPLICIT NONE
+      SUBROUTINE simulate_pos( time_since_reference_local )
+
+         REAL(wp), INTENT(IN) ::  time_since_reference_local  !< local time since reference
 !
 !--      Update apparent solar position based on modified t_s_r_p
-         CALL calc_zenith
+         CALL get_date_time( time_since_reference_local, &
+                             day_of_year=day_of_year,    &
+                             second_of_day=second_of_day )
+         CALL calc_zenith( day_of_year, second_of_day )
          IF ( cos_zenith > 0 )  THEN
 !--         
Index: /palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod and increased binary version
+! 
+! 4146 2019-08-07 07:47:36Z gronemeier
 ! Corrected "Former revisions" section
 ! 
@@ -94,7 +97,4 @@
         ONLY:  cpu_log, log_point_s
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  day_of_year_init, time_utc_init
-
     USE diagnostic_output_quantities_mod,                                      &
         ONLY:  ti_av, uu_av, vv_av, ww_av
@@ -193,5 +193,5 @@
        READ ( 13 )  version_on_file
 
-       binary_version_global = '4.8'
+       binary_version_global = '4.9'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version_global ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning ',           &
@@ -374,6 +374,6 @@
              CASE ( 'damp_level_1d' )
                 READ ( 13 )  damp_level_1d
-             CASE ( 'day_of_year_init' )
-                READ ( 13 )  day_of_year_init
+             CASE ( 'origin_date_time' )
+                READ ( 13 )  origin_date_time
              CASE ( 'dissipation_1d' )
                 READ ( 13 )  dissipation_1d
@@ -638,6 +638,4 @@
              CASE ( 'time_since_reference_point' )
                 READ ( 13 )  time_since_reference_point
-             CASE ( 'time_utc_init' )
-                READ ( 13 )  time_utc_init
              CASE ( 'time_virtual_measurement' )
                 READ ( 13 )  time_virtual_measurement
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4227)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4226 2019-09-10 17:03:24Z suehring
 ! Netcdf input routine for dimension length renamed
 ! 
@@ -8385,8 +8388,4 @@
  SUBROUTINE salsa_emission_setup( init )
 
-    USE date_and_time_mod,                                                                         &
-        ONLY:  day_of_month, hour_of_day, index_dd, index_hh, index_mm, month_of_year,             &
-               time_default_indices, time_utc_init
-
     USE netcdf_data_input_mod,                                                                     &
         ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
@@ -8394,4 +8393,7 @@
                get_dimension_length, open_read_file, street_type_f
 
+    USE palm_date_time_mod,                                                                        &
+        ONLY:  days_per_week, get_date_time, hours_per_day, months_per_year, seconds_per_hour
+
     USE surface_mod,                                                                               &
         ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
@@ -8403,12 +8405,20 @@
     CHARACTER(LEN=25) ::  mod_name             !< name in the input file
 
-    INTEGER(iwp) ::  i         !< loop index
-    INTEGER(iwp) ::  ib        !< loop index: aerosol number bins
-    INTEGER(iwp) ::  ic        !< loop index: aerosol chemical components
-    INTEGER(iwp) ::  id_salsa  !< NetCDF id of aerosol emission input file
-    INTEGER(iwp) ::  in        !< loop index: emission category
-    INTEGER(iwp) ::  inn       !< loop index
-    INTEGER(iwp) ::  j         !< loop index
-    INTEGER(iwp) ::  ss        !< loop index
+    INTEGER(iwp) ::  day_of_month   !< day of the month
+    INTEGER(iwp) ::  day_of_week    !< day of the week
+    INTEGER(iwp) ::  day_of_year    !< day of the year
+    INTEGER(iwp) ::  hour_of_day    !< hour of the day
+    INTEGER(iwp) ::  i              !< loop index
+    INTEGER(iwp) ::  ib             !< loop index: aerosol number bins
+    INTEGER(iwp) ::  ic             !< loop index: aerosol chemical components
+    INTEGER(iwp) ::  id_salsa       !< NetCDF id of aerosol emission input file
+    INTEGER(iwp) ::  in             !< loop index: emission category
+    INTEGER(iwp) ::  index_dd       !< index day
+    INTEGER(iwp) ::  index_hh       !< index hour
+    INTEGER(iwp) ::  index_mm       !< index month
+    INTEGER(iwp) ::  inn            !< loop index
+    INTEGER(iwp) ::  j              !< loop index
+    INTEGER(iwp) ::  month_of_year  !< month of the year
+    INTEGER(iwp) ::  ss             !< loop index
 
     INTEGER(iwp), DIMENSION(maxspec) ::  cc_i2m   !<
@@ -8417,4 +8427,6 @@
 
     LOGICAL, INTENT(in) ::  init  !< if .TRUE. --> initialisation call
+
+    REAL(wp) ::  second_of_day    !< second of the day
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  nsect_emission  !< sectional number emission
@@ -8662,5 +8674,6 @@
 !
 !--             Next emission update
-                next_aero_emission_update = MOD( time_utc_init, 3600.0_wp ) - 3600.0_wp
+                CALL get_date_time( 0.0_wp, second_of_day=second_of_day )
+                next_aero_emission_update = MOD( second_of_day, seconds_per_hour ) - seconds_per_hour
 !
 !--             Get chemical composition (i.e. mass fraction of different species) in aerosols
@@ -8818,5 +8831,7 @@
 !
 !--             Get the index of the current hour
-                CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
+                CALL get_date_time( time_since_reference_point, &
+                                    day_of_year=day_of_year, hour=hour_of_day )
+                index_hh = ( day_of_year - 1_iwp ) * hours_per_day + hour_of_day
                 aero_emission_att%time_factor = aero_emission_att%etf(:,index_hh)
 
@@ -8825,6 +8840,23 @@
 !--             Get the index of current hour (index_hh) (TODO: Now "workday" is always assumed.
 !--             Needs to be calculated.)
-                CALL time_default_indices( daytype, month_of_year, day_of_month, hour_of_day,      &
-                                           index_mm, index_dd, index_hh )
+                CALL get_date_time( time_since_reference_point, &
+                                    month=month_of_year,        &
+                                    day=day_of_month,           &
+                                    hour=hour_of_day,           &
+                                    day_of_week=day_of_week     )
+                index_mm = month_of_year
+                index_dd = months_per_year + day_of_week
+                SELECT CASE(TRIM(daytype))
+
+                   CASE ("workday")
+                      index_hh = months_per_year + days_per_week + hour_of_day
+
+                   CASE ("weekend")
+                      index_hh = months_per_year + days_per_week + hours_per_day + hour_of_day
+
+                   CASE ("holiday")
+                      index_hh = months_per_year + days_per_week + 2*hours_per_day + hour_of_day
+
+                END SELECT
                 aero_emission_att%time_factor = aero_emission_att%etf(:,index_mm) *                &
                                                 aero_emission_att%etf(:,index_dd) *                &
@@ -9119,8 +9151,4 @@
  SUBROUTINE salsa_gas_emission_setup( init )
 
-    USE date_and_time_mod,                                                                         &
-        ONLY:  day_of_month, hour_of_day, index_dd, index_hh, index_mm, month_of_year,             &
-               time_default_indices, time_utc_init
-
     USE netcdf_data_input_mod,                                                                     &
         ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
@@ -9128,4 +9156,7 @@
                get_dimension_length, open_read_file
 
+    USE palm_date_time_mod,                                                                        &
+        ONLY:  days_per_week, get_date_time, hours_per_day, months_per_year, seconds_per_hour
+
     USE surface_mod,                                                                               &
         ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
@@ -9138,9 +9169,18 @@
     CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names   !<  variable names in input data
 
+
+    INTEGER(iwp) ::  day_of_month   !< day of the month
+    INTEGER(iwp) ::  day_of_week    !< day of the week
+    INTEGER(iwp) ::  day_of_year    !< day of the year
+    INTEGER(iwp) ::  hour_of_day    !< hour of the day
     INTEGER(iwp) ::  id_chem        !< NetCDF id of chemistry emission file
     INTEGER(iwp) ::  i              !< loop index
     INTEGER(iwp) ::  ig             !< loop index
     INTEGER(iwp) ::  in             !< running index for emission categories
+    INTEGER(iwp) ::  index_dd       !< index day
+    INTEGER(iwp) ::  index_hh       !< index hour
+    INTEGER(iwp) ::  index_mm       !< index month
     INTEGER(iwp) ::  j              !< loop index
+    INTEGER(iwp) ::  month_of_year  !< month of the year
     INTEGER(iwp) ::  num_vars       !< number of variables
 
@@ -9148,4 +9188,6 @@
 
     LOGICAL, INTENT(in) ::  init          !< if .TRUE. --> initialisation call
+
+    REAL(wp) ::  second_of_day    !< second of the day
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_factor  !< emission time factor
@@ -9258,5 +9300,6 @@
 !
 !--       Next emission update
-          next_gas_emission_update = MOD( time_utc_init, 3600.0_wp ) - 3600.0_wp
+          CALL get_date_time( time_since_reference_point, second_of_day=second_of_day )
+          next_gas_emission_update = MOD( second_of_day, seconds_per_hour ) - seconds_per_hour
 !
 !--       Allocate and read surface emission data (in total PM) (NOTE that "preprocessed" input data
@@ -9303,5 +9346,7 @@
 !
 !--       Get the index of the current hour
-          CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
+          CALL get_date_time( time_since_reference_point, &
+                              day_of_year=day_of_year, hour=hour_of_day )
+          index_hh = ( day_of_year - 1_iwp ) * hours_per_day + hour_of_day
           time_factor = chem_emission_att%hourly_emis_time_factor(:,index_hh)
 
@@ -9310,6 +9355,23 @@
 !--       Get the index of current hour (index_hh) (TODO: Now "workday" is always assumed.
 !--       Needs to be calculated.)
-          CALL time_default_indices( daytype, month_of_year, day_of_month, hour_of_day,            &
-                                     index_mm, index_dd, index_hh )
+          CALL get_date_time( time_since_reference_point, &
+                              month=month_of_year,        &
+                              day=day_of_month,           &
+                              hour=hour_of_day,           &
+                              day_of_week=day_of_week     )
+          index_mm = month_of_year
+          index_dd = months_per_year + day_of_week
+          SELECT CASE(TRIM(daytype))
+
+             CASE ("workday")
+                index_hh = months_per_year + days_per_week + hour_of_day
+
+             CASE ("weekend")
+                index_hh = months_per_year + days_per_week + hours_per_day + hour_of_day
+
+             CASE ("holiday")
+                index_hh = months_per_year + days_per_week + 2*hours_per_day + hour_of_day
+
+          END SELECT
           time_factor = chem_emission_att%mdh_emis_time_factor(:,index_mm) *                       &
                         chem_emission_att%mdh_emis_time_factor(:,index_dd) *                       &
